#ifndef _UNIXTimer_h_INCLUDED_
#define _UNIXTimer_h_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>

/*****************************************************************************/
/* 饹                                                              */
/*****************************************************************************/

typedef struct _UNIXTimer * UNIXTimer;
typedef int (*UNIXTimerCallBack)(void *);

/*****************************************************************************/
/* дؿ                                                          */
/*****************************************************************************/

/*---------------------------------------------------------------------------*/
/* ޤ ON, OFF                                                          */
/*---------------------------------------------------------------------------*/

int UNIXTimer_ON(UNIXTimer unix_timer);
int UNIXTimer_OFF(UNIXTimer unix_timer);
int UNIXTimer_IsON(UNIXTimer unix_timer);
int UNIXTimer_IsOFF(UNIXTimer unix_timer);

/*---------------------------------------------------------------------------*/
/*                                                                   */
/*---------------------------------------------------------------------------*/

/*
 * ؿƬ Pause, Unpause ǤФʤɤϡ
 * ؿؿƤӽФȤˡ Pause, Unpause Τ
 * դ뤳ȡ(ݡϥͥȤǤ)
 */

/*
 * ݡϥͥȤΤǡUNIXTimer_Unpause() °פ˷֤Ƥ
 * ʤ褦դ뤳ȡ
 */

int UNIXTimer_Pause(UNIXTimer unix_timer);
int UNIXTimer_Unpause(UNIXTimer unix_timer);
int UNIXTimer_IsPause(UNIXTimer unix_timer);

/*---------------------------------------------------------------------------*/
/* ȥץꥻå                                                          */
/*---------------------------------------------------------------------------*/

int UNIXTimer_SetAutoPreset(UNIXTimer unix_timer);
int UNIXTimer_ResetAutoPreset(UNIXTimer unix_timer);
int UNIXTimer_IsAutoPreset(UNIXTimer unix_timer);

/*---------------------------------------------------------------------------*/
/* 󥿡Х                                                              */
/*---------------------------------------------------------------------------*/

int UNIXTimer_GetInterval(UNIXTimer unix_timer);
int UNIXTimer_SetInterval(UNIXTimer unix_timer, int interval);

/*---------------------------------------------------------------------------*/
/* ХåؿθƤӽФΥѥ᡼                                  */
/*---------------------------------------------------------------------------*/

void * UNIXTimer_GetParameter(UNIXTimer unix_timer);
void * UNIXTimer_Setparameter(UNIXTimer unix_timer, void * parameter);

/*---------------------------------------------------------------------------*/
/* ХåؿμϿ                                              */
/*---------------------------------------------------------------------------*/

UNIXTimerCallBack UNIXTimer_GetCallBack(UNIXTimer unix_timer);
UNIXTimerCallBack UNIXTimer_SetCallBack(UNIXTimer unix_timer,
					UNIXTimerCallBack callback);

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

UNIXTimer UNIXTimer_Create(int auto_preset, int interval, void * parameter,
			   UNIXTimerCallBack callback);

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

UNIXTimer UNIXTimer_Destroy(UNIXTimer unix_timer);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
